#! /usr/bin/env pythong
# ePycycle bot (Codename Storm)

import string
from ircbot import SingleServerIRCBot
from irclib import nm_to_n, irc_lower
from readconfig import Settings
from user import User

st = Settings()
BotRoot = st.BotRoot
del(st)

UserList = []

helpMessage = """Zeile 1
Zeile 2"""
class ePyCycle(SingleServerIRCBot):
	def __init__(self, server, port, nickname, channel, realname, recon):
		SingleServerIRCBot.__init__(self, [(server, port)], nickname, realname, recon)
		self.channel = channel
		self.start()

	def on_welcome(self, connection, event):
		connection.join(self.channel)
		
	def on_join(self, connection, event):
		"""Source is the user,
		target is the channel"""
		#print "Source: " + event.source() 
		simpleuser = string.split(event.source(), "!", 1)
		print "User joined: " + simpleuser[0]
		#~ if simpleuser[0] != connection.nickname:
			#~ connection.privmsg(event.target(), "Hi " + simpleuser[0])
		#~ else:
			#~ print "Don't like to greet myself"
		
		lists = access()
		lists.load()
		
		#connection.action("#whg", "coded")
		
		if is_in_list(simpleuser[0]) != False:
			print "User is in list"
			index = getIndexOfUser(simpleuser[0])
			#print "Users greet:", UserList[index].getGreet()
			#print event.target()
			
			if UserList[index].getGreet() != "nogreet":
				connection.privmsg(event.target(), UserList[index].getGreet())
			else:
				pass
		else:
			#pass
			print "User is not in list"
		
		
	def on_privmsg(self, connection, event):
		"""on_privmsg - if a privmsg arrives the bot
		uses the Ozone concept"""
		
		# simpleuser[0] ist der nick
		simpleuser = string.split(event.source(), "!", 1)
		#print simpleuser[0]
		if is_in_list(simpleuser[0]) == True:
			acc = access()
			type = acc.gettype(simpleuser[0])
			#print type
			if type == "General":
				print "Command by General User"
				self.gencmd(simpleuser[0], event.arguments()[0], connection)
				self.normcmd(simpleuser[0], event.arguments()[0], connection)
			elif type == "Op":
				print "Command by BotOperator"
				self.opcmd(simpleuser[0], event.arguments()[0], connection)
				self.gencmd(simpleuser[0], event.arguments()[0], connection)
				self.normcmd(simpleuser[0], event.arguments()[0], connection)
			elif type == "Admin":
				print "Command by BotAdmin"
				self.admcmd(simpleuser[0], event.arguments()[0], connection)
				self.opcmd(simpleuser[0], event.arguments()[0], connection)
				self.gencmd(simpleuser[0], event.arguments()[0], connection)
				self.normcmd(simpleuser[0], event.arguments()[0], connection)
				
		else:
			if simpleuser[0] == BotRoot:
				print "Command by BotRoot"
				self.brcmd(simpleuser[0], event.arguments()[0], connection)
				self.admcmd(simpleuser[0], event.arguments()[0], connection)
				self.opcmd(simpleuser[0], event.arguments()[0], connection)
				self.gencmd(simpleuser[0], event.arguments()[0], connection)
				self.normcmd(simpleuser[0], event.arguments()[0], connection)
			else:
				print "Command by Normal User"
				self.normcmd(simpleuser[0], event.arguments()[0], connection)
	def gencmd(self, user, command, connection):
		if command[:4] == "help":
			if command == "help":
				connection.notice(user, "users - displays user information")
			if command[5:] == "users":
				connection.notice(user, "You are a general user")
				connection.notice(user, "Possible users are:")
				connection.notice(user, "Normal users - not listed in ePyCycle")
				connection.notice(user, "General users - have only greet")
				connection.notice(user, "Admin users - actually they can't do anything")
				connection.notice(user, "Op users - like admin users")
				connection.notice(user, "BotRoot - only one person, can do everything")
	def admcmd(self, user, command, connection):
		pass
	def opcmd(self, user, command, connection):
		if command[:3] == "say":
			st = Settings()
			# Get the channel from the configfile, very nice
			connection.privmsg(st.channel, command[4:])
		if command[:6] == "action":
			st = Settings()
			# Send a CTCP Action to the channel, ethereal rules!
			connection.action(st.channel, command[7:])
		elif command[:4] == "help":
			if command == "help":
				connection.notice(user, "say - says something in the channel")
				connection.notice(user, "action - say something about an action in the channel")
			if command[5:] == "say":
				connection.notice(user, "syntax: say <TextToSay>")
				connection.notice(user, "The bot says something in the channel")
			if command[5:] == "action":
				connection.notice(user, "syntax: action <WhatToSay>")
				connection.notice(user, "Action says something about an action in a channel")
				connection.notice(user, "It is like the me command in your client")
	def normcmd(self, user, command, connection):
		if command[:4] == "help":
			if command == "help":
				#connection.notice(user, "Available commands:")
				connection.notice(user, "help - displays this text")
				connection.notice(user, "help version - displays version information")
				#connection.notice(user, "More is not build in yet-Sai")
			if command[5:] == "version":
				connection.notice(user, "ePyCycle Bot by Marek Kubica <gradamani at surfeu dot de>")
			#connection.notice(user, helpMessage)
	
	def brcmd(self, user, command, connection):
		"""BotRoot Command - Executes BotRoot's Commands
		"""
		lists = access()
		if command == "list":
			lists.list(user, connection)
		elif command == "die":
			self.die()
		elif command == "save":
			connection.notice(user, "This is internal and shouldn't be used")
			lists.save()
		elif command == "load":
			connection.notice(user, "This is internal and shouldn't be used")
			lists.load()
		elif command == "debug":
			connection.notice(user, "This is only debug stuff, look on stdout")
			print "UserList: ",
			print UserList
		elif command == "restart":
			self.disconnect()
		elif command[:3] == "add":
			addwho = command[4:]
			added = string.split(addwho, " ", 1)
			print "User: ",
			print added[0]
			greet = string.split(added[1], " ", 1)
			status = greet[0]
			print "Status: ", status
			greet = greet[1]
			print "Greet: ", greet
			
			success = lists.add(added[0], status, greet)
			if success != True:
				connection.notice(user, "Something went wrong!")
		elif command[:6] == "remove":
			removewho = command[7:]
			if lists.remove(removewho) == False:
				connection.notice(user, "No such user")
		elif command[:6] == "status":
			statwho = command[7:]
			if lists.gettype(statwho) == "Admin":
				connection.notice(user, "User is Admin")
			elif lists.gettype(statwho) == "Op":
				connection.notice(user, "User is Operator")
			elif lists.gettype(statwho) == "General":
				connection.notice(user, "User is a general user")
			else:
				connection.notice(user, "User is a normal user")
		elif command[:4] == "help":
			if command == "help":
				connection.notice(user, "add - adds a user")
				connection.notice(user, "remove - removes a user from the list")
				connection.notice(user, "status - gets user's group")
				connection.notice(user, "restart - restarts the bot")
				connection.notice(user, "die - kills the bot")
			if command[5:] == "add":
				connection.notice(user, "Syntax: add <User> <Group> <Greet>")
				connection.notice(user, "Greet is mandatory, if you wish no greet type nogreet for greet")
			if command[5:] == "remove":
				connection.notice(user, "syntax: remove <User>")
			if command[5:] == "list":
				connection.notice(user, "syntax: list")
				connection.notice(user, "Lists all users which are listed in the bot")
			if command[5:] == "status":
				connection.notice(user, "syntax: status <User>")
				connection.notice(user, "Get's users' status (Normal/General/Op/Admin")
			if command[5:] == "restart":
				connection.notice(user, "syntax: restart")
				connection.notice(user, "Disconnects the bot, waits some time and reconnects the bot")
			if command[5:] == "die":
				connection.notice(user, "syntax: die")
				connection.notice(user, "Shuts the bot down")
				
class access:
	def __init__(self):
		#Load Users
		self.load()
	def add(self, user, status, greet):
		"""adds Ozone users to list"""
		if status == "Admin":
			#AdminList.append(user)
			usr = User(user, "Admin", greet)
			UserList.append(usr)
			
			#Save the list, it'll be reloaded on next __init__
			self.save()
			return True
		elif status == "Op":
			#OpList.append(user)
			usr = User(user, "Op", greet)
			UserList.append(usr)
			self.save()
			return True
		elif status == "General":
			usr = User(user, "General", greet)
			UserList.append(usr)
			self.save()
			return True
		else:
			return False
	def remove(self, user):
		"""Uses Mercury and Ozone"""
		
		# Search user in the lists
		if is_in_list(user) == False:
			return False
		else:
			# Where to find the user in the list
			index = getIndexOfUser(user)
			# Remove the user from the list
			UserList.pop(index)
			# Save userlist
			self.save()
			# Load new userlist (maybe not needed)
			self.load()

	def gettype(self, user):
		"""Gettype returns the users type
		Uses Ozone"""
		
		for eachUser in UserList:
			if eachUser.getNickname() == user:
				#print eachUser.getGroup
				return eachUser.getGroup()
		return "Normal"
			
	def list(self, user, connection):
		"""Lists Ozone users"""
		for eachUser in UserList:
			sendnick = eachUser.getNickname() + "+"
			sendnick = sendnick + eachUser.getGroup() + "+"
			sendnick = sendnick + eachUser.getGreet()
			connection.notice(user, sendnick)
	def load(self):
		"""Load uses already the mercury component"""
		#print "List before del_lists:", UserList
		self.del_lists()
		st = Settings()
		st.refresh()
		
		#UserList
		#muss leer sein!!!
		for eachUser in st.UserList:
			UserList.append(eachUser)
		


	def del_lists(self):
		#Delete entire AccessLists
		#Modified to work with Mercury concept
		
		lu = len(UserList)
		#print "Len of UserList:",
		#print lu
		
		if lu != 0:
			lu_not_zero = 1
			while lu_not_zero:
				lu = lu - 1
				#print "Now lu:",
				#print lu
				UserList.pop(lu)
				#print "Now UserList:",
				#print UserList
				#lu = lu - 1
				if lu == 0:
					lu_not_zero = 0
		
	def save(self):

		from writeconfig import ConfigWriter
		
		st = Settings()
		cw = ConfigWriter()
		
		cw.server = st.server
		cw.port = st.port
		cw.channel = st.channel
		cw.reconnect = st.reconnect
		cw.nickname = st.nickname
		cw.realname = st.realname
		cw.BotRoot = st.BotRoot
		
		for eachUser in UserList:
			cw.UserList.append(eachUser)
		cw.write()
		
		#~ oplst = file("oplist.txt","w")
		#~ for nick in OpList:
			#~ oplst.write(nick + "\n")
		#~ oplst.close()
		#~ admlst = file("adminlist.txt","w")
		#~ for nick in AdminList:
			#~ admlst.write(nick + "\n")
		#~ admlst.close()
		
		#~ #genlst = file("genlist.txt", "w")
		#~ #for nick in GeneralList:
		#~ #	genlst.write(nick + "\n")
		#~ #genlst.close()
		
		#~ genlst = file("genlist.txt", "w")
		#~ for eachKey in GeneralList:
			#~ genlst.write(eachKey + "\n")
			#~ genlst.write(GeneralList[eachKey] + "\n")
		#~ genlst.close()
		
	def rfill(self, string_to_fill, lenght):
		"""Fills the string until it is <lenght> long
		"""
		#Attention! Character is not a space it is a ALT+255
		character = ""
		strlen = len(string_to_fill)
		strlen = lenght - strlen
		strlen_not_zero = 1
		while strlen_not_zero:
			string_to_fill = string_to_fill + character
			strlen = strlen -1
			if strlen == 0:
				strlen_not_zero = 0
		return string_to_fill

def main():
	options = loadxmlsettings()
	print "Server: " + options[0]
	print "Port: " + str(options[1])
	print "Nickname: " + options[2]
	print "Realname: " + options[4]
	print "Channel: " + options[3]
	print "Reconnect: " + str(options[5]) + "sec" 
	
	bot = ePyCycle(options[0], options[1], options[2], options[3], options[4], options[5])
	bot.start()

	
def loadxmlsettings():
	#Create Settings object with all xml data
	st = Settings()
	
	#Get data from object
	set_server = st.server
	set_port = st.port
	set_nickname = st.nickname
	set_realname = st.realname
	set_channel = st.channel
	set_recon = st.reconnect

	#Convert strings to ints
	set_port = int(set_port)
	set_recon = int(set_recon)
	
	# make a list
	set_all = [set_server, set_port, set_nickname, set_channel, set_realname, set_recon]
	#print set_all
	
	return set_all
	
def is_in_list(user):
		
	for eachUser in UserList:
		#print "eU", eachUser.getNickname()
		#print "user", user
		if eachUser.getNickname() == user:
			#print "User found"
			return True
		else:
			#return 1
			#print "user not found, searching..."
			pass
	return False
				
	#print "No user found"
	return 1
		
def getIndexOfUser(user):
	index = 0
	for eachUser in UserList:
		if eachUser.getNickname() == user:
			return index
		else:
			index = index + 1
	return None
	
if __name__ == "__main__": main()