#!/usr/bin/env python
# readconfig.py
# Mercury read component

import sys
from xml.sax import make_parser
from confighandler import ConfigHandler

ch = ConfigHandler( )
saxparser = make_parser( )

saxparser.setContentHandler(ch)
saxparser.parse("epycycle.xml")

class Settings:
	server = ch.server
	port = ch.port
	channel = ch.channel
	reconnect = ch.reconnect
	nickname = ch.nickname
	realname = ch.realname

	BotRoot =  ch.BotRoot
	UserList = ch.UserList
	
	def del_lists(self):
		"""Deletes the list - copied from storm"""
		lu = len(self.UserList)
		
		if lu != 0:
			lu_not_zero = 1
			while lu_not_zero:
				lu = lu - 1
				self.UserList.pop(lu)
				if lu == 0:
					lu_not_zero = 0
	
	def refresh(self):
		# Delete lists...
		self.del_lists()
		# ... and parse again!
		saxparser.parse("epycycle.xml")
		

